/** Die Klasse enthlt Methoden, um die Hufigkeit der Zeichen eines Texte zu zhlen
*/
import abiturklassen.baumklassen.BinarySearchTree;
import abiturklassen.baumklassen.Item;
import abiturklassen.listenklassen.List;

public class Zeichenzaehler {
  private BinarySearchTree zeichenZaehlbaum;
  private List sortierteZeichenListe;
  public Zeichenzaehler() {
    zeichenZaehlbaum = new BinarySearchTree();
  }
  
  public void zaehleZeichen(String pText){
    char lZeichen;
    zeichenZaehlbaum = new BinarySearchTree();
    for (int lZaehler=0; lZaehler<pText.length()-1;lZaehler++ ) {
      lZeichen = pText.charAt(lZaehler);
      Zeichenzahl lZeichenzahlNeu=new Zeichenzahl(lZeichen);
//Es wird geprft, ob lZeichen bereits im Suchabum ist
      Zeichenzahl lZeichenzahlAlt=((Zeichenzahl)zeichenZaehlbaum.search(lZeichenzahlNeu));
      if (lZeichenzahlAlt==null)
 //lZeichen ist noch nicht im Suchbaum
         zeichenZaehlbaum.insert(lZeichenzahlNeu);
      else {
 //lZeichen ist bereits im Suchbaum, die Zeichenzahl wird inkrementiert
        lZeichenzahlAlt.erhoeheAnzahl();
      }
    }
    sortierteZeichenListe = new List();
    sortierteListe(zeichenZaehlbaum);
  }
  
   public List getSortierteZeichenliste(){
     return sortierteZeichenListe;
   }
   
/** Durch Inorder-Traversierung des Suchbaums wird eine sortierte
   Liste der Zeichen mit ihren Hufigkeiten generiert.
   @param der Suchbaum
*/
  private void sortierteListe(BinarySearchTree pSuchbaum){
    if (!pSuchbaum.isEmpty()) {
      sortierteListe(pSuchbaum.getLeftTree());
      sortierteZeichenListe.append(pSuchbaum.getItem());
      sortierteListe(pSuchbaum.getRightTree());
    }
  }

}
