import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import abiturklassen.baumklassen.BinaryTree;
/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 22.07.2010
  * @author
  */



public class MorseAlphabet extends JFrame {
  // Anfang Attribute
  private JLabel jlTxt = new JLabel();
  private JTextArea jTAText = new JTextArea("");
  private JLabel jLMorsecode = new JLabel();
  private String[] jList1Data = {};
  private JTextArea jTACode = new JTextArea("");
  private JButton jBcodieren = new JButton();
  private JButton jBdecode = new JButton();
  private JLabel jLAnleitug = new JLabel();
  
    // Ende Attribute
  private MorseCodierer morseCodierer = new MorseCodierer();

  public MorseAlphabet(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 448;
    int frameHeight = 318;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jlTxt.setBounds(24, 24, 34, 16);
    jlTxt.setText("Text");
    jlTxt.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jlTxt);
    jTAText.setBounds(24, 48, 121, 185);
    cp.add(jTAText);
    jLMorsecode.setBounds(288, 24, 100, 16);
    jLMorsecode.setText("Morsecode");
    jLMorsecode.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLMorsecode);
    jTACode.setBounds(288, 48, 121, 185);
    cp.add(jTACode);
    jBcodieren.setBounds(152, 80, 123, 25);
    jBcodieren.setText(">codieren>");
    jBcodieren.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBcodieren_ActionPerformed(evt);
      }
    });
    cp.add(jBcodieren);
    jBdecode.setBounds(152, 144, 123, 25);
    jBdecode.setText("<decodieren<");
    jBdecode.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBdecode_ActionPerformed(evt);
      }
    });
    cp.add(jBdecode);
    jLAnleitug.setBounds(24, 248, 319, 16);
    jLAnleitug.setText("Texte in Grobuchstaben ohne Leerzeichen eingeben");
    jLAnleitug.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLAnleitug);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  public void jBcodieren_ActionPerformed(ActionEvent evt) {
    String lCode = morseCodierer.codierterText(jTAText.getText());
    jTACode.setText(lCode);
  }

  public void jBdecode_ActionPerformed(ActionEvent evt) {
    String lCode = jTACode.getText();
    String lText = morseCodierer.decodierterText(lCode);
    jTAText.setText(lText);
  }

  // Ende Methoden

  public static void main(String[] args) {
    new MorseAlphabet("MorseAlphabet");

  }
}
