import abiturklassen.baumklassen.BinaryTree;

public class MorseCodierer {

       private BinaryTree morseBaum;

       public MorseCodierer() {
         BinaryTree lBaum4Links = new BinaryTree(new Character('H'));
         BinaryTree lBaum4Rechts = new BinaryTree(new Character('V'));
         BinaryTree lBaum3Links = new BinaryTree(new Character('S'), lBaum4Links, lBaum4Rechts);
         lBaum4Links = new BinaryTree(new Character('F'));
         lBaum4Rechts = new BinaryTree();
         BinaryTree lBaum3Rechts = new BinaryTree(new Character('U'), lBaum4Links, lBaum4Rechts);
         BinaryTree lBaum2Links = new BinaryTree(new Character('I'), lBaum3Links, lBaum3Rechts);
         lBaum4Links = new BinaryTree(new Character('L'));
         lBaum4Rechts = new BinaryTree();
         lBaum3Links = new BinaryTree(new Character('R'), lBaum4Links, lBaum4Rechts);
         lBaum4Links = new BinaryTree(new Character('P'));
         lBaum4Rechts = new BinaryTree(new Character('J'));
         lBaum3Rechts = new BinaryTree(new Character('W'), lBaum4Links, lBaum4Rechts);
         BinaryTree lBaum2Rechts = new BinaryTree(new Character('A'), lBaum3Links, lBaum3Rechts);
         BinaryTree lBaum1Links = new BinaryTree(new Character('E'), lBaum2Links, lBaum2Rechts);
         lBaum4Links = new BinaryTree(new Character('B'));
         lBaum4Rechts = new BinaryTree(new Character('X'));
         lBaum3Links = new BinaryTree(new Character('D'), lBaum4Links, lBaum4Rechts);
         lBaum4Links = new BinaryTree(new Character('C'));
         lBaum4Rechts = new BinaryTree(new Character('Y'));
         lBaum3Rechts = new BinaryTree(new Character('K'), lBaum4Links, lBaum4Rechts);
         lBaum2Links = new BinaryTree(new Character('N'), lBaum3Links, lBaum3Rechts);
         lBaum4Links = new BinaryTree(new Character('Z'));
         lBaum4Rechts = new BinaryTree(new Character('Q'));
         lBaum3Links = new BinaryTree(new Character('G'), lBaum4Links, lBaum4Rechts);
         lBaum4Links = new BinaryTree(new Character());
         lBaum4Rechts = new BinaryTree();
         lBaum3Rechts = new BinaryTree(new Character('O'), lBaum4Links, lBaum4Rechts);
         lBaum2Rechts = new BinaryTree(new Character('M'), lBaum3Links, lBaum3Rechts);
         BinaryTree lBaum1Rechts = new BinaryTree(new Character('T'), lBaum2Links, lBaum2Rechts);
         morseBaum = new BinaryTree(new Character(' '), lBaum1Links, lBaum1Rechts);
       }
       
       public String codierterText (String pText) {
         int lZaehler = 0;
          String lCode = "";
          while ((lZaehler < pText.length()) && (pText.charAt (lZaehler) >= 'A') && (pText.charAt (lZaehler) <= 'Z')) {
           lCode = lCode + erzeugeMorsecode (pText.charAt(lZaehler), morseBaum, "") + "/";
           lZaehler++;
         }
         return lCode;
       }
       
       public String erzeugeMorsecode (char pZeichen, BinaryTree pmorseBaum, String pCode) {
          if (!pmorseBaum.isEmpty()){
           if (pZeichen == ((Character) pmorseBaum.getObject()).charValue()){
             return pCode;
           }
           else {
             String lCodeLinkerTeilbaum = erzeugeMorsecode(pZeichen, pmorseBaum.getLeftTree(), pCode+".");
             if (lCodeLinkerTeilbaum.equals(""))
               return erzeugeMorsecode(pZeichen, pmorseBaum.getRightTree(), pCode+"-");
             else
               return lCodeLinkerTeilbaum;
           }
          }
          else
            return "";
       }
       
  public String decodierterText (String pCode) {
    int lZaehler = 1;
    String lText = "";
    String lMorsezeichen;
    if(pCode.charAt(pCode.length()-1) != '/');
     pCode = pCode + '/';
    do {
      lMorsezeichen=pCode.substring(0, pCode.indexOf('/'));
      pCode = pCode.substring(pCode.indexOf('/')+1,pCode.length());
      if (lMorsezeichen != "") {
        lText=lText+decodiertesZeichen(lMorsezeichen);
      }
    } while (!pCode.equals(""));
        return lText;
  }

  public Character decodiertesZeichen( String pZeichenCode){
    String lText = "";
    int lZaehler = 0;
    BinaryTree lBaum = morseBaum;
    while (lZaehler < pZeichenCode.length()) {
      if (pZeichenCode.charAt(lZaehler) == '.')
        lBaum = lBaum.getLeftTree();
      else
        lBaum = lBaum.getRightTree();
      lZaehler++;
    }
    return (Character)lBaum.getObject();
  }

}
