import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.JTextField;
import javax.swing.JFormattedTextField;
import abiturklassen.graphklassen.*;

/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 03.08.2010
  * @author
  */



public class GraphAnwendung extends JFrame {
  // Anfang Attribute
  private JButton jKnoten = new JButton();
  private JTextField jTextVon = new JTextField();
  private JTextField jTextNach = new JTextField();
  private JTextField jTextGewicht = new JTextField();
  private JButton jButtonKante = new JButton();
  private JLabel jLabelVon = new JLabel();
  private JLabel jLabelNach = new JLabel();
  private JLabel jLabelGewicht = new JLabel();
  private JTable jTableGraph = new JTable(8, 8);
  
  Wegsuche wegsuche = new Wegsuche();
  int knotenZahl = 0;
  private JLabel jLabelVon1 = new JLabel();
  private JTextField jTextVon1 = new JTextField();
  private JLabel jLabelNach1 = new JLabel();
  private JTextField jTextNach1 = new JTextField();
  private JButton jButtonWegsuche = new JButton();
  private JTextArea jTextAreaWeg = new JTextArea("");
  // Ende Attribute

  public GraphAnwendung(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 553;
    int frameHeight = 447;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten

    jKnoten.setBounds(48, 48, 139, 25);
    jKnoten.setText("Knoten einfgen");
    jKnoten.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jKnoten_ActionPerformed(evt);
      }
    });
    cp.add(jKnoten);
    jTextVon.setBounds(232, 48, 33, 24);
    jTextVon.setText("");
    cp.add(jTextVon);
    jTextNach.setBounds(312, 48, 33, 24);
    jTextNach.setText("");
    cp.add(jTextNach);
    jTextGewicht.setBounds(416, 48, 41, 24);
    jTextGewicht.setText("0");
    cp.add(jTextGewicht);
    jButtonKante.setBounds(200, 88, 267, 25);
    jButtonKante.setText("Kante einfgen");
    jButtonKante.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButtonKante_ActionPerformed(evt);
      }
    });
    cp.add(jButtonKante);
    jLabelVon.setBounds(208, 48, 22, 16);
    jLabelVon.setText("von");
    jLabelVon.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabelVon);
    jLabelNach.setBounds(280, 48, 29, 16);
    jLabelNach.setText("nach");
    jLabelNach.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabelNach);
    jLabelGewicht.setBounds(360, 48, 47, 16);
    jLabelGewicht.setText("Gewicht");
    jLabelGewicht.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabelGewicht);
    jTableGraph.setBounds(56, 160, 296, 208);
    jTableGraph.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    TableColumn col;
    for (int i = 0; i < jTableGraph.getColumnCount(); i++) {
      int vColIndex = i;
      col = jTableGraph.getColumnModel().getColumn(vColIndex);
      int width = 60;
      col.setPreferredWidth(60);
    }
    jTableGraph.setRowHeight(25);
    cp.add(jTableGraph);
    jLabelVon1.setBounds(368, 160, 22, 16);
    jLabelVon1.setText("von");
    jLabelVon1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabelVon1);
    jTextVon1.setBounds(392, 160, 33, 24);
    jTextVon1.setText("");
    cp.add(jTextVon1);
    jLabelNach1.setBounds(440, 160, 29, 16);
    jLabelNach1.setText("nach");
    jLabelNach1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
    cp.add(jLabelNach1);
    jTextNach1.setBounds(472, 160, 33, 24);
    jTextNach1.setText("");
    cp.add(jTextNach1);
    jButtonWegsuche.setBounds(368, 200, 139, 25);
    jButtonWegsuche.setText("Ein Weg");
    jButtonWegsuche.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jButtonWegsuche_ActionPerformed(evt);
      }
    });
    cp.add(jButtonWegsuche);
    jTextAreaWeg.setBounds(368, 248, 137, 121);
    jTextAreaWeg.setText("");
    cp.add(jTextAreaWeg);
    // Ende Komponenten

    setResizable(false);
    setVisible(true);
  }

  // Anfang Methoden
  public void jKnoten_ActionPerformed(ActionEvent evt) {
    if (knotenZahl < 7) {
       GraphNode knoten = wegsuche.knotenEinfuegen();
       String name = knoten.getName();
       jTableGraph.setValueAt(name, 0, knotenZahl+1);
       jTableGraph.setValueAt(name, knotenZahl+1, 0);
       knotenZahl++;
    }

  }

  public void jButtonKante_ActionPerformed(ActionEvent evt) {
    String nameKnoten1 = jTextVon.getText();
    String nameKnoten2 = jTextNach.getText();
    Double gewicht = Double.parseDouble(jTextGewicht.getText());
    if ( !nameKnoten1.equals(nameKnoten2) && (wegsuche.kanteEinfuegen(nameKnoten1, nameKnoten2, gewicht))) {
      int position1 = (int) nameKnoten1.charAt(0) - (int) 'A';
      int position2 = (int) nameKnoten2.charAt(0) - (int) 'A';
      jTableGraph.setValueAt(gewicht, position1+1, position2+1);
      jTableGraph.setValueAt(gewicht, position2+1, position1+1);

    }
  }

  public void jButtonWegsuche_ActionPerformed(ActionEvent evt) {
         String start = jTextVon1.getText();
    String ziel = jTextNach1.getText();
    abiturklassen.listenklassen.List kurzweg = wegsuche.gibWeg(start,ziel);
    kurzweg.toFirst();
    String wegBeschreibung = "";
    while (kurzweg.hasAccess()) {
       wegBeschreibung = wegBeschreibung + ((GraphNode) kurzweg.getObject()).getName()+" ";
       kurzweg.next();
    }
    wegBeschreibung = wegBeschreibung + wegsuche.gibWegLaenge(kurzweg);
    jTextAreaWeg.setText(wegBeschreibung);
  }

  // Ende Methoden

  public static void main(String[] args) {
    new GraphAnwendung("GraphAnwendung");
  }
}
